import terrylib.*;

class Main {
	var title:Bool=true;
	function DoTitle(){	
		Text.changesize(32);	
		Text.display(0, 120-16, "FORGETRIS");
		Text.changesize(16);
		Text.display(0,120-16+50," press X to start");
		if (Input.justpressed(Key.X)||Input.justpressed(Key.C)){
			title=false;
		}
	}
	var t:Int=0;
	var offsetX:Int=40;
	var offsetY:Int=7;
	var margin:Int=0;
	var tileSize:Int=10;
	var gridWidth:Int=10;
	var gridHeight:Int=24;
	var hideTop:Int=2;
	var hideBottom:Int=2;
	var brickMargin:Int=1;

	public var px:Int=0;
	public var py:Int=0;
	public var ptype:Int=0;
	public var pnexttype:Int=0;
	public var prot:Int=0;
	var colors:Array<Int> = [
	0xff0000,0x00ff00,0x0000ff,
	0xdddd00,0xff00ff,0x00ffff,
	0xFFA500];	

	function new() {
		pnexttype=Random.int(0,piecetypes.length-1);
		SpawnPiece();
	}

	public function SpawnPiece(){
		py=0;
		px=Std.int(gridWidth/2-2);
		ptype = pnexttype;		
		pnexttype = Random.int(0,piecetypes.length-1);
		prot = 0;//Random.int(0,piecetypes[ptype].length-1);
	}

	public function DrawPixelPiece(type:Int,rot:Int,x:Int,y:Int){

		for (i in 0...4){
			for (j in 0...4){
				if (piecetypes[type][rot][i][j]==1){
					var posx=tileSize*(i)+x;
					var posy=tileSize*(j)+y;
					Gfx.fillbox(posx+brickMargin,posy+brickMargin,tileSize-2*brickMargin,tileSize-2*brickMargin,colors[type]);
				}
			}
		}
	}

	public function DrawPiece(type:Int,rot:Int,x:Int,y:Int){
		trace(type,rot,x,y);
		for (i in 0...4){
			for (j in 0...4){
				if (j+y<hideTop || j+y>=(gridHeight-hideBottom)){
					continue;
				}
				if (piecetypes[type][rot][i][j]==1){
					var posx=offsetX+tileSize*(x+i);
					var posy=offsetY+tileSize*(y+j);
					Gfx.fillbox(posx+brickMargin,posy+brickMargin,tileSize-2*brickMargin,tileSize-2*brickMargin,colors[type]);
				}
			}
		}
	}

	public function MovePiece(mx:Int,my:Int,mrot:Int):Void
	{
		var trot:Int = (prot+mrot + piecetypes[ptype].length)%piecetypes[ptype].length;
		if (CanFit(px+mx,py+my,ptype,trot))
		{
			px+=mx;
			py+=my;
			prot=trot;
		}			
	}

	public static var piecetypes:Array<Array<Array<Array<Int>>>> = [ 
			[
				[
					[0,0,0,0],
					[0,1,1,0],
					[0,1,1,0],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[1,1,1,1],
					[0,0,0,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,0],
					[0,0,1,0],
					[0,0,1,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,0,1,1],
					[0,1,1,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,1],
					[0,0,0,1],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,1,1,0],
					[0,0,1,1],
					[0,0,0,0]
				],
				[
					[0,0,0,1],
					[0,0,1,1],
					[0,0,1,0],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,1,1,1],
					[0,1,0,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,0],
					[0,0,1,1],
					[0,0,0,0]
				],
				[
					[0,0,0,1],
					[0,1,1,1],
					[0,0,0,0],
					[0,0,0,0]
				],
				[
					[0,1,1,0],
					[0,0,1,0],
					[0,0,1,0],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,1,1,1],
					[0,0,0,1],
					[0,0,0,0]
				],
				[
					[0,0,1,1],
					[0,0,1,0],
					[0,0,1,0],
					[0,0,0,0]
				],
				[
					[0,1,0,0],
					[0,1,1,1],
					[0,0,0,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,0],
					[0,1,1,0],
					[0,0,0,0]
				],
			],
			[
				[
					[0,0,0,0],
					[0,1,1,1],
					[0,0,1,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,0,1,1],
					[0,0,1,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,1,1,1],
					[0,0,0,0],
					[0,0,0,0]
				],
				[
					[0,0,1,0],
					[0,1,1,0],
					[0,0,1,0],
					[0,0,0,0]
				],
			],
		];


	public function CanFit(x:Int,y:Int,type:Int,rot:Int):Bool
	{
		for (i in 0...4)
		{
			for (j in 0...4)
			{
				
				if (piecetypes[ptype][rot][i][j]>0)
				{
					
					if (y+j<0 || y+j>=gridHeight || x+i<0 || x+i>=gridWidth)
						return false;
				}
			}
		}
		return true;
	}
	
	
	function ValidPos():Bool {
		return (CanFit(px,py,ptype,prot));
		/*
		if (py>gridHeight) {
			return false;
		} else if (px<0) {
			return false;
		} else if (px>gridWidth){
			return false;
		}
		return true;*/
	}


	function DropByOne(){
		py++;
		if (!ValidPos()){
			SpawnPiece();
		}
	}

	function TryDrop(){
		DropByOne();
	}

	var u:Int=0;
	function DoGame(){
		t++;
		u++;
		if (Input.justpressed(Key.LEFT)){
			px--;
			if (!ValidPos()){
				px++;
			}	
			u=0;		
		} else if (Input.pressed(Key.LEFT)){
			if (u%7==0){
				px--;
				if (!ValidPos()){
					px++;
				}					
			}
		}
		if (Input.justpressed(Key.RIGHT)){
			px++;
			if (!ValidPos()){
				px--;
			}
			u=0;
		}else if (Input.pressed(Key.RIGHT)){
			if (u%7==0){
				px++;
				if (!ValidPos()){
					px--;
				}					
			}
		}
		if(Input.justpressed(Key.X)||Input.justpressed(Key.C)||(Input.justpressed(Key.UP))){
			var dir:Int=Input.justpressed(Key.X)?1:-1;
			var oldRot=prot;
			prot=(((prot+dir)%piecetypes[ptype].length)+piecetypes[ptype].length)%piecetypes[ptype].length;
			if (!ValidPos()){
				prot=oldRot;
			}
		}
		if (Input.justpressed(Key.DOWN)){

			t=1;
			TryDrop();
		} else if (Input.pressed(Key.DOWN)){
			if (t%5==0){
				t=1;
				TryDrop();
			}
		}

		if (t%30==0){
			t=0;
			DropByOne();
		}
		Gfx.fillbox(offsetX-margin,offsetY-margin+hideTop*tileSize,tileSize*gridWidth+2*margin,tileSize*(gridHeight-hideTop-hideBottom)+2*margin,0xffffff);	
		
		Text.display(offsetX-margin+tileSize*gridWidth+2*margin+40,offsetY-margin+hideTop*tileSize-10,"next:");	
		var nextX:Int=offsetX-margin+tileSize*gridWidth+2*margin+50;
		var nextY:Int=offsetY-margin+hideTop*tileSize+20;
		Gfx.fillbox(nextX,nextY,4*tileSize,4*tileSize,0xffffff);	

		DrawPixelPiece(pnexttype,0,nextX,nextY);

		Text.display(184,95,"score\n000000");
		Text.display(184,160,"level\n   0");
		DrawPiece(ptype,prot,px,py);
	}
	function update() {
		if (title){
			DoTitle();
			return;
		}
		DoGame();
	}
}
